Alien::Build::MM(3)

NAME
Alien::Build::MM - Alien::Build installer code for ExtUtils::MakeMaker

VERSION
version 1.67

SYNOPSIS
In your "Makefile.PL":

 use ExtUtils::MakeMaker;
 use Alien::Build::MM;

 my $abmm = Alien::Build::MM->new;

 WriteMakefile($abmm->mm_args(
   ABSTRACT     => 'Discover or download and install libfoo',
   DISTNAME     => 'Alien-Libfoo',
   NAME         => 'Alien::Libfoo',
   VERSION_FROM => 'lib/Alien/Libfoo.pm',
   ...
 ));

 sub MY::postamble {
   $abmm->mm_postamble;
 }

In your "lib/Alien/Libfoo.pm":

 package Alien::Libfoo;
 use base qw( Alien::Base );
 1;

In your alienfile (needs to be named "alienfile" and should be in the root of your dist):

 use alienfile;

 plugin 'PkgConfig' => 'libfoo';

 share {
   start_url 'http://libfoo.org';
   ...
 };

DESCRIPTION
This class allows you to use Alien::Build and Alien::Base with ExtUtils::MakeMaker. It load the alienfile recipe in the root of your Alien dist, updates the prereqs passed into "WriteMakefile" if any are specified by your alienfile or its plugins, and adds a postamble to the "Makefile" that will download/build/test the alienized package as appropriate.

The alienfile must be named "alienfile".

If you are using Dist::Zilla to author your Alien dist, you should consider using the Dist::Zilla::Plugin::AlienBuild plugin.

I personally don't recommend it, but if you want to use Module::Build instead, you can use Alien::Build::MB.

CONSTRUCTOR

  new
 my $abmm = Alien::Build::MM->new;

Create a new instance of Alien::Build::MM.

PROPERTIES

  build
 my $build = $abmm->build;

The Alien::Build instance.

  alienfile_meta
 my $bool = $abmm->alienfile_meta

Set to a false value, in order to turn off the x_alienfile meta

METHODS

  mm_args
 my %args = $abmm->mm_args(%args);

Adjust the arguments passed into "WriteMakefile" as needed by Alien::Build.

  mm_postamble
 my $postamble $abmm->mm_postamble;

Returns the postamble for the "Makefile" needed for Alien::Build. This adds the following "make" targets which are normally called when you run "make all", but can be run individually if needed for debugging.

alien_prefix
    Determines the final install prefix ("%{.install.prefix}").

alien_version
    Determine the perl_module_version ("%{.runtime.perl_module_version}")

alien_download
    Downloads the source from the internet. Does nothing for a system install.

alien_build
    Build from source (if a share install). Gather configuration (for either system or share install).

alien_prop
    Prints the meta, install and runtime properties for the Alien.

SEE ALSO
Alien::Build, Alien::Base, Alien, Dist::Zilla::Plugin::AlienBuild, Alien::Build::MB

AUTHOR
Author: Graham Ollis <plicease@cpan.org>

Contributors:

Diab Jerius (DJERIUS)

Roy Storey

Ilya Pavlov

David Mertens (run4flat)

Mark Nunberg (mordy, mnunberg)

Christian Walde (Mithaldu)

Brian Wightman (MidLifeXis)

Zaki Mughal (zmughal)

mohawk (mohawk2, ETJ)

Vikas N Kumar (vikasnkumar)

Flavio Poletti (polettix)

Salvador Fandiño (salva)

Gianni Ceccarelli (dakkar)

Pavel Shaydo (zwon, trinitum)

Kang-min Liu (劉康民, gugod)

Nicholas Shipp (nshp)

Juan Julián Merelo Guervós (JJ)

Joel Berger (JBERGER)

Petr Pisar (ppisar)

Lance Wicks (LANCEW)

Ahmad Fatoum (a3f, ATHREEF)

José Joaquín Atria (JJATRIA)

Duke Leto (LETO)

Shoichi Kaji (SKAJI)

Shawn Laffan (SLAFFAN)

Paul Evans (leonerd, PEVANS)

COPYRIGHT AND LICENSE
This software is copyright (c) 2011-2019 by Graham Ollis.

This is free software; you can redistribute it and/or modify it under the same terms as the Perl 5 programming language system itself.